var jPhidget22 = require('phidget22');

var SERVER_PORT = 5661;

function main() {

	if (process.argv.length != 3) {
		console.log('usage: node RFID.js <server address>');
		process.exit(1);
	}

	var url = 'phid://' + process.argv[2] + ':' + SERVER_PORT;

	console.log('connecting to:' + url);
	var conn = new jPhidget22.Connection(url, { name: 'Server Connection', passwd: '' });
	conn.connect()
	  .then(runExample)
	  .catch(function (err) {
	  	console.log('Error running example:' + err);
		process.exit(1);
	  });
}

function runExample() {

	console.log('connected to server');
	var ch = new jPhidget22.RFID();

	ch.onAttach = function(ch) {
		console.log(ch + ' attached');
	};

	ch.onDetach = function(ch) {
		console.log(ch + ' detached');
	};

	ch.onTag = function(tag, protocol) {
		var protocolStr;
		switch(protocol) {
			case jPhidget22.RFIDProtocol.PROTOCOL_EM4100:
				protocolStr = 'PROTOCOL_EM4100';
				break;
			case jPhidget22.RFIDProtocol.PROTOCOL_ISO11785_FDX_B:
				protocolStr = 'PROTOCOL_ISO11785_FDX_B';
					break;
			case jPhidget22.RFIDProtocol.PROTOCOL_PHIDGETS:
				protocolStr = 'PROTOCOL_PHIDGETS';
				break;
		}
		
		console.log('Tag: ' + tag + "\tProtocol: " + protocolStr)
	}
	
	ch.onTagLost = function(tag, protocol) {
		var protocolStr;
		switch(protocol) {
			case jPhidget22.RFIDProtocol.PROTOCOL_EM4100:
				protocolStr = 'PROTOCOL_EM4100';
				break;
			case jPhidget22.RFIDProtocol.PROTOCOL_ISO11785_FDX_B:
				protocolStr = 'PROTOCOL_ISO11785_FDX_B';
					break;
			case jPhidget22.RFIDProtocol.PROTOCOL_PHIDGETS:
				protocolStr = 'PROTOCOL_PHIDGETS';
				break;
		}
		
		console.log('TagLost: ' + tag + "\tProtocol: " + protocolStr)
	}
	
	ch.open().then(function (ch) {
		console.log('channel open');
	}).catch(function (err) {
		console.log('failed to open the channel:' + err);
	});
}

if (require.main === module)
	main();
